#    most of this task is now taken from the standard application

set VERSION "ML403"

#    put some default environment variables before loading common 


set LinuxDirectory  /MIDAS/Data_Acq/bin/linux-ppc405/
set DAProgram ML403ExecV1

loadsource  sys.common

set env(RDOUThdwre) GPIO

set Supported_Modules {}


lappend setuplist [list "Show histogram name translations" "Show_Xlate"]
lappend setuplist [list "Edit histogram translation file"  "edit_xlate"]

set frametitle "MIDAS Data Acquisition Experiment Control (ML403)"

set TSPresent 1
set TSEnable 0
set txEnable 0

set histEnable 1
set HistMode 1

set TestBuffer ""

set Options(Include.ML403) 1

proc create_spectra {} {
   global SpectrumServer HistMode EGreport

   if {$HistMode == 0} {return}
   
   set-footer "Creating spectra"
   set-busy

   set EGreport_SAVE $EGreport
   set EGreport -1

   Make_Xlate $SpectrumServer

   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 512 :name 'Stat' !new)" } m]
   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 512 :name 'Rate' !new)" } m]

   map_spectrum "Stat 0 0"      ;#  map as group 0 item 0

#   for the data channels

   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 1024 :name 'Off' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            display-eg-error-report self $m "Attempting to create spectrum Off"
            clear-footer
            error $m
         } else {
            map_spectrum  "Off 1 0 0 0"    ;# map as group =1;  item =0
         }

   set z [catch {eg "(spectrum :path '/$SpectrumServer' :range 1024 :name 'On' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            display-eg-error-report self $m "Attempting to create spectrum On"
            clear-footer
            error $m
         } else {
            map_spectrum  "On 1 1 0 0"    ;# map as group =1;  item =1
         }

   set EGreport $EGreport_SAVE

   clear-busy
   clear-footer
}


proc Stop_Electronics {} {
}

proc Go_Electronics {} {

    write-register NetVar.DACQ.PollTicks 50
}

proc Reset_Electronics {} {
}


proc make-registers {} {
    global registerlist RegisterServer RDOUTserverList
    global EGreport EGallow

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

    set EGreport_SAVE $EGreport
    set EGreport -1

    set EGallow 0x10004

    set RegisterServer [first $RDOUTserverList]

    set rc [catch {read-register NetVar.EXEC.ID} m]
    if {$m == 0x10004} {
        foreach item $registerlist {
            set-footer "defining register [first $item]"
            define-register [second $item] [first $item] "[third $item]"
        }
    }

    clear-footer
    set EGreport $EGreport_SAVE
    set EGallow -1
}

proc make-executiveregisters {} {
    global executiveregisters RegisterServer RDOUTserverList
    global EGreport EGallow

   global RDOUTEnable; if {$RDOUTEnable == 0} then {return}

    set EGreport_SAVE $EGreport
    set EGreport -1

    set EGallow 0x10004

    set RegisterServer [first $RDOUTserverList]

    set rc [catch {read-register NetVar.Executive.ID} m]
    if {$m == 0x10004} {
        foreach item $executiveregisters {
            set-footer "defining register [first $item]"
            define-register [second $item] [first $item] "[third $item]"
        }
    }

    clear-footer
    set EGreport $EGreport_SAVE
    set EGallow -1
}
